#!/bin/python

from requests import get
from datetime import datetime 
from argparse import ArgumentParser
from io import open
from os import environ
import json

# Ledger's manual says this script should reference the $LEDGER_PRICE_DB environment variable
# to determin price db location. My case I define LEDGER_PRICE_DB=/home/jstn/ledger/prices

SYMBOLS={
    "SPX",
    "GOOGL"
}
parser = ArgumentParser()
parser.add_argument("--database")
args = parser.parse_args()

file = environ["LEDGER_PRICE_DB"]
db = open(file)
content = db.read()
db.close()
    
KEY="<your key>"
URL="https://www.alphavantage.co/query?function=TIME_SERIES_DAILY"
def request(symbol):
    r = get(URL + "&symbol=" + symbol + "&apikey=" + KEY)
    if r.status_code != 200:
        print(r.text)
        exit()
    return r.json()

for symbol in SYMBOLS:
    r = request(symbol)
    now = datetime.now()
    value = str(r["Time Series (Daily)"][r["Meta Data"]["3. Last Refreshed"]]["1. open"])
    entry = [
        "P",
        now.strftime("%Y/%m/%d %H:%M:%S"),
        symbol,
        value,
        "USD",
        "\n"
    ]
    content += ' '.join(entry)
open(file, "w").write(content)
